// SpinDlg.cpp : Implementation of CSpinDlg
#include "stdafx.h"
#include "tmxlib.h"
#include "SpinDlg.h"
#include "Spin.h"

/////////////////////////////////////////////////////////////////////////////
// CSpinDlg

CSpinDlg::CSpinDlg()
{
	m_hwSpin = m_hwEdit = NULL;
	m_spin = NULL;
}

CSpinDlg::~CSpinDlg()
{
}

void CSpinDlg::Update()
{
	if (m_spin)
	{
		short upper;
		short lower;
		m_spin->GetSpinBounds(lower,upper);
		if (lower>=upper)
		{
			upper = UD_MAXVAL/2;
			lower = UD_MINVAL/2;
		}
		::SendMessage(m_hwSpin,UDM_SETRANGE,0,(LPARAM) MAKELONG(upper,lower));
		m_spin->GetSpinPos(upper);
		::SendMessage(m_hwSpin,UDM_SETPOS,0,(LPARAM) MAKELONG(upper,0));
	}
}

LRESULT CSpinDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_hwSpin = GetDlgItem(IDC_SPIN);
	m_hwEdit = GetDlgItem(IDC_EDIT);
	Update();
	return 1;  // Let the system set the focus
}

LRESULT CSpinDlg::OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
//	EndDialog(wID);	 - to prevent destroying of the window
	return 0;
}

LRESULT CSpinDlg::OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
//	EndDialog(wID);	 - to prevent destroying of the window
	return 0;
}

LRESULT CSpinDlg::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	WORD nWidth = LOWORD(lParam);
	WORD nHeight = HIWORD(lParam);
	if (nHeight && nWidth)
	{	// Resize children
		::SetWindowPos(m_hwEdit,NULL,2,2,nWidth-4,nHeight-4,SWP_NOZORDER|SWP_NOMOVE);
		::PostMessage(m_hwSpin,UDM_SETBUDDY,(WPARAM)(HWND)m_hwEdit,0);
	}
	return 0;
}

LRESULT CSpinDlg::OnDeltaPos(int id, LPNMHDR hdr, BOOL&)
{
	NMUPDOWN *udn = (NMUPDOWN*)hdr;
	if (udn && hdr->code==UDN_DELTAPOS)		// Inform SPIN control..
		if (!m_spin->SetSpinPos(udn->iPos+udn->iDelta))
			udn->iDelta = 0;
	return 0;
}
