// SpinPage.cpp : Implementation of CSpinPage
#include "stdafx.h"
#include "tmxlib.h"
#include "SpinPage.h"

/////////////////////////////////////////////////////////////////////////////
// CSpinPage

LRESULT CSpinPage::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_minSpin = GetDlgItem(IDC_MINSPIN);
	m_maxSpin = GetDlgItem(IDC_MAXSPIN);
	if (m_nObjects)
	{
		ItmSpin* i_spin;
		m_ppUnk[0]->QueryInterface(IID_ItmSpin, (void**)&i_spin);
		if (i_spin)
		{
			CH_CHANNEL chinfo;
			spin_data_t data;
			i_spin->GetSpinData(&data);
			IChInfo *i_chi = 0;
			ItmChBrowser *chbr = 0;
			i_spin->QueryInterface(IID_IChInfo,(void**)&i_chi);
			if (i_chi)
			{
				i_chi->GetChanBrowser((LPUNKNOWN*)&chbr);
				i_chi->GetChInfo(&data.chi);
				if (chbr)
				{
					chbr->AddRef();
					chinfo.chId = data.chi.chanId;
					if (chbr->GetChanInfo(&chinfo)==S_OK)
					{
						if (chinfo.type & CHTP_HEX)
							data.flags |= TMX_HEX;
						else
						{
							data.flags &= ~TMX_HEX;
							if (chinfo.scl[0]<chinfo.scl[1] && (data.flags & TMX_MINMAXFROMSCALE))
							{
								data.v_min.f = chinfo.scl[0];
								data.v_max.f = chinfo.scl[1];
							}
						}
						i_spin->SetSpinData(&data);
					}
					chbr->Release();
				}
				i_chi->Release();
			}
			CheckDlgButton(IDC_VISIBLEATSTART,(data.flags & TMX_VISIBLEATSTART)!=0);
			CheckDlgButton(IDC_SCALETOMINMAX,(data.flags & TMX_MINMAXFROMSCALE)!=0);
			::SendMessage(m_minSpin,UDM_SETRANGE,0,
							(LPARAM)MAKELONG(UD_MAXVAL/2,UD_MINVAL/2));
			::SendMessage(m_maxSpin,UDM_SETRANGE,0,
							(LPARAM)MAKELONG(UD_MAXVAL/2,UD_MINVAL/2));
			::SendMessage(m_minSpin,UDM_SETPOS,0,
							(LPARAM)MAKELONG(short(data.v_min.f),0));
			::SendMessage(m_maxSpin,UDM_SETPOS,0,
							(LPARAM)MAKELONG(short(data.v_max.f),0));
			i_spin->Release();
		}
	}
	return 1;
}

// Update 'data' by current page state
void CSpinPage::Update(spin_data_t& data)
{
	if (IsDlgButtonChecked(IDC_VISIBLEATSTART))
		data.flags |=  TMX_VISIBLEATSTART;
	else
		data.flags &=  ~TMX_VISIBLEATSTART;
	if (IsDlgButtonChecked(IDC_SCALETOMINMAX))
		data.flags |=  TMX_MINMAXFROMSCALE;
	else
		data.flags &=  ~TMX_MINMAXFROMSCALE;
	data.v_min.f = short(LOWORD(::SendMessage(m_minSpin,UDM_GETPOS,0,0)));
	data.v_max.f = short(LOWORD(::SendMessage(m_maxSpin,UDM_GETPOS,0,0)));
}

