// SpinPage.h : Declaration of the CSpinPage

#ifndef __SPINPAGE_H_
#define __SPINPAGE_H_

#include "resource.h"       // main symbols

EXTERN_C const CLSID CLSID_SpinPage;

/////////////////////////////////////////////////////////////////////////////
// CSpinPage
class ATL_NO_VTABLE CSpinPage :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSpinPage, &CLSID_SpinPage>,
	public IPropertyPageImpl<CSpinPage>,
	public CDialogImpl<CSpinPage>
{
public:
	CSpinPage() 
	{
		m_dwTitleID = IDS_TITLESpinPage;
		m_dwHelpFileID = IDS_HELPFILESpinPage;
		m_dwDocStringID = IDS_DOCSTRINGSpinPage;
		m_minSpin = m_maxSpin = NULL;
	}
	HWND m_minSpin;
	HWND m_maxSpin;

	enum {IDD = IDD_SPINPAGE};

DECLARE_REGISTRY_RESOURCEID(IDR_SPINPAGE)

BEGIN_COM_MAP(CSpinPage) 
	COM_INTERFACE_ENTRY_IMPL(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(CSpinPage)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(IPropertyPageImpl<CSpinPage>)
	COMMAND_HANDLER(IDC_SCALETOMINMAX, BN_CLICKED, OnSetDirty)
	COMMAND_HANDLER(IDC_VISIBLEATSTART, BN_CLICKED, OnSetDirty)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void Update(spin_data_t& data);

	LRESULT OnSetDirty(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		SetDirty(1);
		return 0;
	}

	STDMETHOD(Apply)(void)
	{
		// Trace mode doesn'n allow multiply editing..
		if (m_hWnd && m_nObjects)
		{
			ItmSpin* i_spin;
			m_ppUnk[0]->QueryInterface(IID_ItmSpin, (void**)&i_spin);
			if (i_spin)
			{
				spin_data_t data;
				i_spin->GetSpinData(&data);
				Update(data);
				i_spin->SetSpinData(&data);
				i_spin->Release();
			}
		}
		m_bDirty = FALSE;
		return S_OK;
	}
};

#endif //__SPINPAGE_H_
